using System;
using System.IO;
using System.Collections;
using System.Runtime.InteropServices;
using System.Drawing;
using System.Drawing.Imaging;
using System.Windows.Forms;

namespace GdiPlusLib
{

    /// <summary>
    /// gdiplus.dllg߂̃bp[NX
    /// </summary>
    public class Gdip
    {
        private static ImageCodecInfo[] codecs = ImageCodecInfo.GetImageEncoders();

        /// <summary>
        /// t@C̊gqGDIR[fbN擾
        /// </summary>
        /// <param name="filename">t@C</param>
        /// <param name="clsid"> outĉ</param>
        /// <returns></returns>
        private static bool getCodecClsid(string filename, out Guid clsid)
        {
            clsid = Guid.Empty;
            string ext = Path.GetExtension(filename); // gq擾
            if (ext == null)
                return false;
            ext = "*" + ext.ToUpper();
            foreach (ImageCodecInfo codec in codecs)
            {
                if (codec.FilenameExtension.IndexOf(ext) >= 0) // gqŃR[fbN
                {
                    clsid = codec.Clsid; // R[fbNID
                    return true;
                }
            }
            return false;
        }

        /// <summary>
        /// t@Cɕۑ_CAOoāAbitmapۑ
        ///  2,3ڂtH
        /// </summary>
        /// <param name="picname"></param>
        /// <param name="bminfo">bitmapւ̃|C^</param>
        /// <param name="pixdat">bitmap̃sNZ</param>
        /// <returns></returns>
        public static bool saveFile(string fileName, IntPtr bminfo, IntPtr pixdat)
        {
            Guid clsid; // R[fbNIDi[p̃O[oʎq
            if (!getCodecClsid(fileName, out clsid)) // t@Cۑ_CAOAt@Cp
            {
                // R[fbN
                MessageBox.Show("Unknown picture format for extension " + Path.GetExtension(fileName),
                                "Image Codec", MessageBoxButtons.OK, MessageBoxIcon.Information);
                return false;
            }

            IntPtr img = IntPtr.Zero; // GDIƗpbitmapւ̋̃|C^
            int st = GdipCreateBitmapFromGdiDib(bminfo, pixdat, ref img); // BitmapH
            if ((st != 0) || (img == IntPtr.Zero))
                return false;

            st = GdipSaveImageToFile(img, fileName, ref clsid, IntPtr.Zero); // R[fbN`ɍ킹ăt@Cɏo
            GdipDisposeImage(img);
            return st == 0;
        }

        #region Methods imported from dll

        /// <summary>
        /// GDI̍ƗpbitmapH
        /// 12tۂ
        /// </summary>
        /// <param name="bminfo"></param>
        /// <param name="pixdat"></param>
        /// <param name="image"></param>
        /// <returns></returns>
        [DllImport("gdiplus.dll", ExactSpelling = true)]
        internal static extern int GdipCreateBitmapFromGdiDib(IntPtr bminfo, IntPtr pixdat, ref IntPtr image);

        /// <summary>
        /// 摜R[fbN`w肵āAt@Cɏoۑ
        /// </summary>
        /// <param name="image">bitmapւ̃|C^</param>
        /// <param name="filename">t@C</param>
        /// <param name="clsid">R[fbNID</param>
        /// <param name="encparams"></param>
        /// <returns></returns>
        [DllImport("gdiplus.dll", ExactSpelling = true, CharSet = CharSet.Unicode)]
        internal static extern int GdipSaveImageToFile(IntPtr image, string filename, [In] ref Guid clsid, IntPtr encparams);

        /// <summary>
        /// GDI̍Ɨpbitmap
        /// </summary>
        /// <param name="image">bitmapւ̃|C^</param>
        /// <returns></returns>
        [DllImport("gdiplus.dll", ExactSpelling = true)]
        internal static extern int GdipDisposeImage(IntPtr image);

        #endregion

    }

} // namespace GdiPlusLib
