using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using TwainLib;

namespace TwainCapture
{
    /// <summary>
    /// Twain@Rg[tH[
    /// </summary>
    public partial class TwainControlForm : Form, IMessageFilter
    {

        /// <summary>
        /// RXgN^
        /// </summary>
        public TwainControlForm()
        {
            InitializeComponent();

            comboBoxExt.Text = "jpg"; // gqIR{{bNX
            comboBoxExt.Items.Add("bmp"); // gqǉ
            comboBoxExt.Items.Add("jpg");
            comboBoxExt.Items.Add("gif");
            comboBoxExt.Items.Add("png");
            comboBoxExt.Items.Add("tif");

            this.ext = comboBoxExt.Text; // ftHggqݒ
            this.FilePath = fileNameRefresh(ext); // t@Cݎ琶

            this.twain = new Twain(); // Twain@Rg[pNX
            twain.Init(this.Handle); // EBhEnh(ꉽH)n
        }

        #region Properties

        private Twain twain; // TWAIN@Rg[pNX
        private string fileName; // ۑt@C
        private string ext = "jpg"; // gq
        private bool msgWaitFlag; // Twain@킩̃R[obN҂Ă邩ǂ

        #endregion

        #region Accessor

        /// <summary>
        /// ۑt@Cw
        /// </summary>
        public string FilePath
        {
            set
            {
                this.fileName = value;
            }
            get
            {
                return this.fileName;
            }
        }

        #endregion

        #region Methods

        /// <summary>
        /// Twain@ŎBe
        /// </summary>
        /// <param name="showUI"></param>
        public void acquire(bool showUI)
        {
            if (!msgWaitFlag)
            { // bZ[W҂ĂȂ
                this.Enabled = false; // Form̗vf[UłȂlɂ
                msgWaitFlag = true; // TWAIN@Ƃ̃bZ[WdʐMh
                Application.AddMessageFilter(this);
                FilePath = fileNameRefresh(this.ext); // t@CݎōXV
                twain.Acquire(showUI); // Be
            }
        }

        /// <summary>
        /// ݎt@C𐶐
        /// </summary>
        /// <param name="ext">gq</param>
        /// <returns></returns>
        private String fileNameRefresh(string ext)
        {
            DateTime now = DateTime.Now; // ݎ
            return Application.StartupPath + @"\" + // fBNgpX
                now.Year + now.Month + now.Day + now.Hour + now.Minute + now.Second + // 
                "."+ext; // gq
        }

        #endregion

        /// <summary>
        /// TWAIN@ƃAvP[VԂ̃bZ[WR[obN֐
        /// </summary>
        /// <param name="m"></param>
        /// <returns></returns>
        bool IMessageFilter.PreFilterMessage(ref Message m)
        {
            TwainCommand cmd = twain.PassMessage(ref m); // bZ[WTWAINR}hM
            if (cmd == TwainCommand.Not)
                return false;

            switch (cmd)
            {
                case TwainCommand.CloseRequest:
                    {
                        EndingScan(); // BeȈԃtOǗ\bh
                        twain.CloseSrc();
                        break;
                    }
                case TwainCommand.CloseOk:
                    {
                        EndingScan();
                        twain.CloseSrc();
                        break;
                    }
                case TwainCommand.DeviceEvent:
                    {
                        break;
                    }
                case TwainCommand.TransferReady: // ʐ^M
                    {
                        ArrayList pics = twain.TransferPictures(); // ʐ^Xg擾
                        EndingScan();
                        twain.CloseSrc();
                        TwainImage tImg = new TwainImage((IntPtr)pics[0]); // Ƃ肠1ڂ
                        tImg.saveFile(this.FilePath); // t@Cɕۑ
                        break;
                    }
            }

            return true;
        }

        /// <summary>
        /// BeI ImessageFilter.PreFilterMessage()Ă΂
        /// </summary>
        private void EndingScan()
        {
            if (msgWaitFlag) // TwaiñbZ[W҂ǂ
            {
                Application.RemoveMessageFilter(this); // WindosbZ[W
                msgWaitFlag = false;
                this.Enabled = true; // [UtH[𑀍łlɂ
                this.Activate();
            }
        }

        #region Events of FormItem

        /// <summary>
        /// Twain@I{^
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void buttonSelect_Click(object sender, EventArgs e)
        {
            twain.Select(); // @I
        }

        /// <summary>
        /// ZbeBO{^
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void buttonSetting_Click(object sender, EventArgs e)
        {
            this.acquire(true); // TwainWUI\
        }

        /// <summary>
        /// Be{^
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void buttonAcquir_Click(object sender, EventArgs e)
        {
            this.acquire(false); // UI\ɁAȂBe
        }

        /// <summary>
        /// gqIR{{bNX𑀍삵
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void comboBoxExt_SelectedIndexChanged(object sender, EventArgs e)
        {
            this.ext = comboBoxExt.Items[comboBoxExt.SelectedIndex].ToString();
        }

        #endregion

    }
}