using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;
using System.Drawing;

using GdiPlusLib;

namespace TwainLib
{

    /// <summary>
    /// bitmapgdiplus.dllɓn߂̍\̒`
    /// </summary>
    [StructLayout(LayoutKind.Sequential, Pack = 2)]
    internal class BITMAPINFOHEADER
    {
        public int biSize;
        public int biWidth;
        public int biHeight;
        public short biPlanes;
        public short biBitCount;
        public int biCompression;
        public int biSizeImage;
        public int biXPelsPerMeter;
        public int biYPelsPerMeter;
        public int biClrUsed;
        public int biClrImportant;
    }

    /// <summary>
    /// Twain@킩M摜f[^̊ǗNX
    /// </summary>
    public class TwainImage
    {

        /// <summary>
        /// RXgN^
        /// </summary>
        /// <param name="dibhandp">bitmapւ̃|C^</param>
        public TwainImage(IntPtr dibhandp)
        {
            dibhand = dibhandp; // bitmapւ̃|C^
            bmpptr = GlobalLock(dibhand); // kernel32ŃO[obN|C^̎擾
            pixptr = GetPixelInfo(bmpptr); // sNZւ̃|C^̎擾
        }

        #region params
        Rectangle bmprect;
        BITMAPINFOHEADER bmi;
        IntPtr dibhand; // TWAIN󂯎bitmapւ̃|C^
        IntPtr bmpptr; // GlobalLockꂽbitmapւ̃|C^
        IntPtr pixptr; // GlobalLockꂽbitmapւ̃|C^̃sNZ
        #endregion

        /// <summary>
        /// t@Cɕۑ
        /// </summary>
        /// <param name="fileName">t@C</param>
        /// <returns></returns>
        public bool saveFile(String fileName)
        {
            return Gdip.saveFile(fileName, bmpptr, pixptr); // t@Cɕۑ
        }

        /// <summary>
        /// bitmapւ̃|C^sNZ擾A|C^ŕԂ
        /// </summary>
        /// <param name="bmpptr">Bitmapւ̃|C^</param>
        /// <returns>sNZւ̃|C^</returns>
        protected IntPtr GetPixelInfo(IntPtr bmpptr)
        {
            bmi = new BITMAPINFOHEADER();
            Marshal.PtrToStructure(bmpptr, bmi);

            bmprect.X = bmprect.Y = 0;
            bmprect.Width = bmi.biWidth;
            bmprect.Height = bmi.biHeight;

            if (bmi.biSizeImage == 0)
                bmi.biSizeImage = ((((bmi.biWidth * bmi.biBitCount) + 31) & ~31) >> 3) * bmi.biHeight;

            int p = bmi.biClrUsed;
            if ((p == 0) && (bmi.biBitCount <= 8))
                p = 1 << bmi.biBitCount;
            p = (p * 4) + bmi.biSize + (int)bmpptr;
            return (IntPtr)p;
        }

        #region Methods imported from dll
        [DllImport("gdi32.dll", ExactSpelling = true)]
        internal static extern int SetDIBitsToDevice(IntPtr hdc, int xdst, int ydst,
                                                int width, int height, int xsrc, int ysrc, int start, int lines,
                                                IntPtr bitsptr, IntPtr bmiptr, int color);

        [DllImport("kernel32.dll", ExactSpelling = true)]
        internal static extern IntPtr GlobalLock(IntPtr handle);
        [DllImport("kernel32.dll", ExactSpelling = true)]
        internal static extern IntPtr GlobalFree(IntPtr handle);

        [DllImport("kernel32.dll", CharSet = CharSet.Auto)]
        public static extern void OutputDebugString(string outstr);
        #endregion

    }

}
